
%define pname akvcam

Name:           dkms-%{pname}
Version:        1.2.5
Release:        %mkrel 1
Summary:        akvcam, virtual camera for Linux 
License:        GPL-2.0+
Group:          System/Kernel
Url:            https://github.com/webcamoid/akvcam/releases/tag/%{version}
Source:         %{pname}-%{version}.tar.xz

Patch0:			akvcam-%{version}-Makefile-pclos.patch
# now updated in tar-ball
#Patch1:			akvcam-fix-gstlaunch.patch

BuildRequires:  gcc
BuildRequires:  make

Requires:		dkms
Requires:		dkms-minimal
Requires(post):		dkms
Requires(preun):	dkms
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
###BuildArch:	noarch
Provides:	%{name} = %{version}
Provides:	kmod(%{pname}.ko) = %{version}


%description
akvcam is a fully compliant V4L2 virtual camera driver for Linux.
Features:
Flexible configuration with a simple INI file like.
Support for map, user pointer, and read/write modes.
Can cat and echo to the device.
Supports emulated camera controls in capture devices
(brightness, contrast, saturation, etc.).
Configurable default picture in case no input signal available.
The devices can't be rejected by programs that rejects M2M devices.
Fully compliant with V4L2 standard.
Support for LTS kernels.

Examples and hint's are placed on
/usr/share/akvcam/ config_example.ini

%prep
%setup -qn %{pname}-%{version}

%autopatch -p1


%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a ./src/* %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__install -dm755 %{buildroot}%{_sysconfdir}/%{pname}
%__cp -a ./share/config_example.ini %{buildroot}%{_sysconfdir}/%{pname}/config.ini
%__install -dm755 %{buildroot}%{_datadir}/%{pname}/examples
%__cp -a ./share/config_example.ini %{buildroot}%{_datadir}/%{pname}/config_example.ini
%__cp -a ./share/examples/output.c %{buildroot}%{_datadir}/%{pname}/examples/output.c
%__rm -rf %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME="%{pname}"
BUILT_MODULE_LOCATION="./"
DEST_MODULE_LOCATION="/kernel/3rdparty/%{pname}"
MAKE="export IGNORE_CC_MISMATCH=1; 'make' KSRC=\${kernel_source_dir} SKIP_STACK_VALIDATION=1 all"
CLEAN="make clean"
AUTOINSTALL="yes"
EOF

%post -n %{name}
# rmmod can fail
/sbin/rmmod %{pname} >/dev/null 2>&1 ||:
/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release} || :

/sbin/modprobe -r %{pname}  >/dev/null 2>&1 ||:
/sbin/modprobe videodev  >/dev/null 2>&1 ||:
/sbin/modprobe %{pname}  >/dev/null 2>&1 ||:

echo "%{pname}" >> /etc/modprobe.preload

%preun -n %{name}
# rmmod can fail
/sbin/rmmod %{pname} >/dev/null 2>&1 ||:
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all || :
## remove module-destdir just if it empty after dkms remove,(user's only deinstall after testing)... ##
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/%{pname}/* ]; then
rm -rf /lib/modules/*/kernel/3rdparty/%{pname}  >/dev/null 2>&1 ||:
fi
sed -i '/%{pname}/ d' /etc/modprobe.preload

%clean
rm -rf %{buildroot}

%files -n %{name}
%defattr(-,root,root)
%{_usrsrc}/%{pname}-%{version}-%{release}/*
%doc README.md CONTRIBUTING.md COPYING
%{_datadir}/%{pname}/config_example.ini
%{_datadir}/%{pname}/examples/output.c
%config(noreplace) %{_sysconfdir}/%{pname}/config.ini


%changelog
* Sat Feb 10 2024 onkelho <oh.quait at gmail.com> - 1.2.5-1quait2024
- new version rel
- Fixed missing V4L2_DEVICE_NAME_SIZE variable in Linux version > 6.7 (issue #80).

* Sat Apr 01 2023 onkelho <oh.quait at gmail.com> - 1.2.3-2pclos2022
- rebuild against updates in Qt, ffmpeg, ...
- add P1 - fix  gst-launch doesn't appear to work with akvcam #20   2 weeks ago
- - Minimum number of buffers decreased to 2.
- - As suggested in issue #20, gst-launch is now working fine.

* Mon Oct 03 2022 onkelho <oh.quait at gmail.com> - 1.2.3-1pclos2022
- new version release

* Wed Jun 15 2022 onkelho <oh.quait at gmail.com> - 1.2.2-9pclos2022
- rebuild

* Wed Jun 15 2022 onkelho <oh.quait at gmail.com> - 1.2.2-5pclos2022
- rebuild - clean all tree's in kernel+dkms from preinstalles before build here
- fix makefile patching and relevants

* Sat Jun 11 2022 onkelho <oh.quait at gmail.com> - 1.2.2-4pclos2022
- rebuild - fix makefile patching and relevants

* Tue Jun 07 2022 onkelho <oh.quait at gmail.com> - 1.2.2-3pclos2022
- rebuild to fix "modprobe: ERROR: could not insert 'akvcam': Exec format error"
- on kernel-5.18.2-pclos1
- patch the makefile
- add /etc/%{pname}/config.ini + move the example.ini to /usr/share/akvcam/...

* Mon Jun 06 2022 onkelho <oh.quait at gmail.com> - 1.2.2-2pclos2022
- Video dequeue ioctl bufix. 

* Mon Jan 31 2022 onkelho <oh.quait at gmail.com> - 1.2.2-1pclos2022
- new version release -- droped akvcam.pro
- add export IGNORE_CC_MISMATCH=1;

* Wed Sep 09 2020 onkelho <oh.quait at gmail.com> - 1.1.0-1pclos2020
- new version release

* Tue Jun 09 2020 onkelho <oh.quait at gmail dot com> 1.0.4-2pclos2020
- rebuild add patch for kernel-5.7

* Mon Apr 13 2020 onkelho <oh.quait at gmail.com> - 1.0.4-1pclos2020
- new version released

* Thu Apr 09 2020 onkelho <oh.quait at gmail.com> - 1.0.3-2pclos2020
- Update to support 5.6 kernel
- Fixed wrong reference pass.
- Added missing header.
- This must fix V4L2_CAP_EXT_PIX_FORMAT undecladed. 

* Mon Mar 30 2020 onkelho <oh.quait at gmail.com> - 1.0.3-1pclos2020
- new version release Mar 28 2020

* Tue Aug 13 2019 onkelho <oh.quait at gmail.com> - 1.0.2-1pclos2019
- new version release
